/*******************************************************************************
 * Copyright (c) 2025, Jan Koester jan.koester@gmx.net
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 * Redistributions of source code must retain the above copyright
 *      notice, this list of conditions and the following disclaimer.
 * Redistributions in binary form must reproduce the above copyright
 *      notice, this list of conditions and the following disclaimer in the
 *      documentation and/or other materials provided with the distribution.
 * Neither the name of the <organization> nor the
 *      names of its contributors may be used to endorse or promote products
 *      derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL <COPYRIGHT HOLDER> BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *******************************************************************************/

#include <uuidp.h>
#include <string>
#include <vector>
#include <cstring>

#include "backend.h"
#include "authdb.h"

#pragma once

#ifdef Windows
#define VISIBILITY __declspec(dllexport)
#else
#define VISIBILITY __attribute__((visibility("default")))
#endif

namespace authdb {
    class VISIBILITY UserData : public AuthData{
    public:
        UserData(const uuid::uuid &id);

        ~UserData();

        void setUserName(const std::string &src);
        const std::string getUsername();

        void setFirstName(const std::string &src);
        const std::string getFirstname();

        void setLastName(const std::string &src);
        const std::string getLastname();

        void setMail(const std::string &src);
        const std::string getMail();

        void setPwHash(const std::string &src);
        const std::string getPwHash();

        void setKrbKey(const std::string &src);
        const std::string getKrbKey();

        void setAvatar(const std::vector<char> &src);
        void getAvatar(std::vector<char> &dest);

    private:
        AuthData::Record* username;
        AuthData::Record* firstname;
        AuthData::Record* lastname;
        AuthData::Record* mail;
        AuthData::Record* pwhash;
        AuthData::Record* krbkey;
        //optional
        AuthData::Record* avatar;
        friend class User;
    };

    class VISIBILITY User {
    public:
        void create(AuthBackend &backend,class UserData *dat);
        void remove(AuthBackend &backend,const uuid::uuid &uid);
        bool exits(AuthBackend &backend,const uuid::uuid &uid,const std::string &name, int &ret);

        void edit(AuthBackend &backend,class UserData &dat,size_t &pos);
        void info(AuthBackend &backend,class UserData &dat,size_t &pos);
    };

    class UserAPi{
    public:
        UserAPi();
        ~UserAPi();
    private:
    };

};
